# -*- coding: utf-8 -*-


class Tag(object):
    def __init__(self, name, params=None, inner='', pair=True):
        if params is None:
            params = {}

        self.name = name
        self.params = params

        if not hasattr(self, 'noclass') and self.__class__.__name__ != 'Tag':
            self.params['class'] = self.__class__.__name__

        self.inner = ''.join([
            str(el) for el in inner
        ]) if type(inner) in [list, tuple] else inner
        self.pair = pair

    def __str__(self):
        params_rendered = ''

        if self.params:
            for param in filter(lambda x: x[1] != False, self.params.items()):
                param_name, param_value = param
                params_rendered += ' %s="%s"' % (param_name, param_value if param_value != True else '')

        if self.pair:
            html = '<%(name)s%(params)s>%(inner)s</%(name)s>' % {
                'name': self.name,
                'inner': self.inner,
                'params': params_rendered or '',
            }
        else:
            html = '<%(name)s%(params)s />' % {
                'name': self.name,
                'params': params_rendered or '',
            }

        return html
