# -*- coding: utf-8 -*-


def all_subclasses(cls):
    return cls.__subclasses__() + [g for s in cls.__subclasses__() for g in all_subclasses(s)]


class CSS(object):
    @classmethod
    def collect_subclasses(cls):
        return cls.__subclasses__() + [g for s in cls.__subclasses__() for g in all_subclasses(s)]

    def css(self):
        classes = [self.__class__] + [obj for obj in self.collect_subclasses()]
        classes_members = {
            klass: list(
                filter(
                    lambda x: not callable(getattr(klass, x)) and not x.startswith('__'),
                    dir(klass)
                )
            ) for klass in classes
        }
        filtered_classes = {k: v for k, v in classes_members.items() if v}
        rendered_classes = {
            klass.__name__: ''.join(
                ['%s:%s;' % (str(k).replace('_', '-'), getattr(klass, k)) for k in styles]
            ) for klass, styles in filtered_classes.items()
        }

        compiled_classes = ''.join(
            ['.%s{%s}' % (
                css_class, css_style
            ) for css_class, css_style in rendered_classes.items()]
        )

        return compiled_classes
